<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" 
  "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en" lang="en" dir="ltr">
<head>
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<link rel="stylesheet" type="text/css" href="doug.css" />
<link rel="shortcut icon" href="/favicon.ico" />
<title>Director Online</title>
<script type="text/javascript">
//<![CDATA[
function MM_openBrWindow(theURL,winName,features) { //v2.0
  window.open(theURL,winName,features);
}
//]]>
</script>
</head>

<body>
<div id="page">


<!-- HEADER -->
<table border="0" cellspacing="0" cellpadding="0"><tr>
<td style="background-image:url(images/dougmenu-left.gif)" width="336" height="132"><a href="/" id="logo" title="Home"></a></td>
<td style="background-image:url(images/dougmenu-middle.gif)" width="432" height="132"><!--432-->
<table border="0" cellpadding="2" cellspacing="0">

<tbody><tr><td align="right" valign="top" width="415">
<a class="dougmenulink" href="articles.php">Articles Archive</a><br />
<a class="dougmenulink" href="search.php">Articles Search</a><br />
<a class="dougmenulink" href="dougwiki/">Director Wiki</a><br />
</td></tr></tbody></table>
</td>
<td style="background-image:url(images/dougmenu-right.gif)" width="18" height="120">&nbsp;</td>
</tr>
</table>
<!-- /HEADER -->

<div id="main">
<h1>Flash + Director = not quite so slow</h1>
<p><font size="-1">July 25, 2000<br />by <a href="articles.php?authID=50">Gary Rosenzweig</a></font></p>
<p>Two weeks ago I wrote a column about how slow Flash members inside Director movies are. They are slow; no one disagreed. However, I did make a mistake (actually, a double mistake) in my method. The first mistake was to assume that the little-known Flash member property <font face="Courier, monotype" color="#CC0000">static</font> was the same as the <font face="Courier, monotype" color="#CC0000">pausedAtStart</font> property. It would seem to make sense that if a Flash member were paused, Director would treat it as if it were static. Not so. They are separate properties, and they give different results in the speed test.</p>
<p>The double mistake came when I used the <font face="Courier, monotype" color="#CC0000">loop</font> property, rather than the <font face="Courier, monotype" color="#CC0000">pausedAtStart</font> property, in my tests. If you check that old column, you can see that the demo movie allowed you to see the <font face="Courier, monotype" color="#CC0000">loop</font> property. I'm not sure why I did that, except that I was thinking in terms of single-frame Flash movies. In that case, <font face="Courier, monotype" color="#CC0000">loop</font> and <font face="Courier, monotype" color="#CC0000">pausedAtStart</font> are not very different.</p>
<p>Here is an updated test movie. This provides controls for both <font face="Courier, monotype" color="#CC0000">pausedAtStart</font> and <font face="Courier, monotype" color="#CC0000">static</font>.</p>
<p><object classid="clsid:166B1BCA-3F9C-11CF-8075-444553540000" codebase="http://active.macromedia.com/director/cabs/sw.cab#version=6,0,1,0" width="300" height="200"><param name="SRC" value="howto/other/LL24_1.dcr" />
<param name="swRemote" value="swTarget='false'" />
<param name="swLiveConnect" value="FALSE" />
<embed src="howto/other/LL24_1.dcr" pluginspage="http://www.macromedia.com/shockwave/download/" type="application/x-director" width="300" height="200" swliveconnect="FALSE" swremote="swTarget='false'" /> </object></p>
<p>Using the "Flash over Flash" test, with high quality on and <font face="Courier, monotype" color="#CC0000">pausedAtStart</font> and <font face="Courier, monotype" color="#CC0000">static</font> off, I got the result of 3900 milliseconds. Changing the <font face="Courier, monotype" color="#CC0000">pausedAtStart</font> to on, the results were the same. However, turning <font face="Courier, monotype" color="#CC0000">static</font> on got me 1400 milliseconds. Quite an improvement!</p>
<p>The champion, however, is still "Bitmap over Bitmap" with 1100. This isn't quite as impressive a margin as in the previous tests, however. Also, note that I did these tests on my G3 Powerbook this time, not my G4 desktop. So the numbers from the old column and these numbers shouldn't be compared -- but their ratios should.</p>
<p>I did the same tests in Shockwave on an 800 MHz Pentium III with a fast video card. Both "Flash over Flash" and "Bitmap over Bitmap" came out at 300 milliseconds when the Flash <font face="Courier, monotype" color="#CC0000">static</font> property was turned on. A tie? Well, impossible to tell, since 300 milliseconds to go about 300 frames means that the 999 fps limit was reached in both cases. The Powerbook test was a little more revealing.</p>
<p>Rather than just leave it at "Flash is still a little slower than bitmaps," I want to propose a solution involving Imaging Lingo. You can get the <font face="Courier, monotype" color="#CC0000">image</font> property of a Flash member, just as you can get the image property of a bitmap. Once you have this image, you can create a new bitmap with it. This bitmap will look exactly like the Flash member, but it will be faster.</p>
<p>Here is a short behavior that does this. It will take the image of the Flash member, create a new bitmap, and place the image in it. Then, it will swap the Flash member for the bitmap in the sprite. To be neat, when the sprite is done it will erase the bitmap.</p>
<p><font color="#000000" face="Verdana, Arial, Helvetica, sans-serif" size="-1"><font color="#0000C8">property</font> pMember</font></p>
<p><font color="#000000" face="Verdana, Arial, Helvetica, sans-serif" size="-1"><b><font color="#0000C8">on</font> <font color="#008000">beginSprite</font> <font color="#0000C8">me</font></b></font></p>
<p><font color="#000000" face="Verdana, Arial, Helvetica, sans-serif" size="-1">&nbsp;&nbsp;<font color="#C80000" face="Courier New, Courier, mono" size="-1">-- make new member</font><br />
&nbsp;&nbsp;pMember = <font color="#0000C8">new</font>(<font color="#008000">#</font>bitmap)</font></p>
<p><font color="#000000" face="Verdana, Arial, Helvetica, sans-serif" size="-1">&nbsp;&nbsp;<font color="#C80000" face="Courier New, Courier, mono" size="-1">-- copy image to member</font><br />
&nbsp;&nbsp;pMember.image = <font color="#008000">sprite</font>(<font color="#0000C8">me</font>.<font color="#008000">spriteNum</font>).<font color="#008000">member</font>.image</font></p>
<p><font color="#000000" face="Verdana, Arial, Helvetica, sans-serif" size="-1">&nbsp;&nbsp;<font color="#C80000" face="Courier New, Courier, mono" size="-1">-- set the sprite to this new member</font><br />
&nbsp;&nbsp;<font color="#008000">sprite</font>(<font color="#0000C8">me</font>.<font color="#008000">spriteNum</font>).<font color="#008000">member</font> = pMember</font></p>
<p><font color="#000000" face="Verdana, Arial, Helvetica, sans-serif" size="-1"><font color="#0000C8">end</font></font></p>
<p><font color="#000000" face="Verdana, Arial, Helvetica, sans-serif" size="-1"><b><font color="#0000C8">on</font> <font color="#008000">endSprite</font> <font color="#0000C8">me</font></b><br />
&nbsp;&nbsp;<font color="#C80000" face="Courier New, Courier, mono" size="-1">-- sprite done, get rid of the evidence</font><br />
&nbsp;&nbsp;erase pMember<br />
<font color="#0000C8">end</font></font></p>
<p>The advantage of this technique over using just a bitmap to begin with, is that you don't have to create and store a bitmap in your movie. This should cut down on file size. Plus, it might make it easier for a programmer to work with a Flash artist. When the Flash artist delivers a new Flash movie, nothing has to be done other than importing it into the Director movie. The conversion happens on the fly. the other advantage, of course, is a slight speed increase. (<b>Note</b>: This works great in Director, but apparently it does not work at all in Shockwave! All I get, Mac and PC, is a black box instead of the Flash member's image. I tried all sorts of workarounds, like having the bitmap already on the Stage, forcing the <font face="Courier, monotype" color="#CC0000">useAlpha</font> of the new bitmap to TRUE, etc. None of these work. If anyone finds a solution, let me know. Otherwise, the next technique will work for static images as well as animated ones).</p>
<p>For animated Flash movies, you can do something very similar. Instead of just converting the initial frame of the Flash member to an image, you can create a list of images from each frame in the Flash movie. A nice way to do this would be to loop through the frames of the Flash member, grab an image from each frame, store it in a list, and then replay the list of images through a single bitmap. Unfortunately, there is a problem with this. You can't tell a Flash member which frame to go to. It is always on the first frame.</p>
<p>But wait a minute, what about the <font face="Courier, monotype" color="#008000">goToFrame</font> Flash member command? Well, that is a sprite command, not a member command. You can tell a Flash sprite to go to any frame you want, but the member will still be at frame 1.</p>
<p>One way around this would be to capture the <font face="Courier, monotype" color="#CC0000">image</font> of the sprite, not the member. Unfortunately, you can't do this. But you can capture the <font face="Courier, monotype" color="#CC0000">image</font> of the Stage. So, you can display the member on the Stage in a sprite, tell it to <font face="Courier, monotype" color="#008000">goToFrame</font> for each frame, grab the image from the Stage, and build the list that way.</p>
<p>The major disadvantage of this is that the user will see this happening. You can find a way to mask this, either by a "rendering images..." message or by using the image capture as an intro animation.</p>
<p>Once the images are in a list, you can set the image of a temporary bitmap to each image in the list. To make this match the frame rate of the original Flash movie, you can use a timer to determine when the next image should be displayed. Here is the code for this behavior.</p>
<p><font color="#000000" face="Verdana, Arial, Helvetica, sans-serif" size="-1"><font color="#0000C8">property</font> pGotImages, pMember, pNumberOfImages<br />
<font color="#0000C8">property</font> pImages, pImageNum, pFrameRate, pNextFrame</font></p>
<p><font color="#000000" face="Verdana, Arial, Helvetica, sans-serif" size="-1"><b><font color="#0000C8">on</font> <font color="#008000">beginSprite</font> <font color="#0000C8">me</font></b></font></p>
<p><font color="#000000" face="Verdana, Arial, Helvetica, sans-serif" size="-1">&nbsp;&nbsp;<font color="#C80000" face="Courier New, Courier, mono" size="-1">-- can't update stage during beginSprite, so set flag to do it on first exitFrame</font><br />
&nbsp;&nbsp;pGotImages = <font color="#0000C8">FALSE</font></font></p>
<p><font color="#000000" face="Verdana, Arial, Helvetica, sans-serif" size="-1"><font color="#0000C8">end</font></font></p>
<p><font color="#000000" face="Verdana, Arial, Helvetica, sans-serif" size="-1"><b><br />
<font color="#0000C8">on</font> getImages <font color="#0000C8">me</font></b></font></p>
<p><font color="#000000" face="Verdana, Arial, Helvetica, sans-serif" size="-1">&nbsp;&nbsp;<font color="#C80000" face="Courier New, Courier, mono" size="-1">-- save original loc, and then set sprite to middle of Stage</font><br />
&nbsp;&nbsp;origLoc = <font color="#008000">sprite</font>(<font color="#0000C8">me</font>.<font color="#008000">spriteNum</font>).<font color="#008000">loc</font><br />
&nbsp;&nbsp;<font color="#008000">sprite</font>(<font color="#0000C8">me</font>.<font color="#008000">spriteNum</font>).<font color="#008000">loc</font> = <font color="#008000">point</font>((<font color="#0000C8">the</font> <font color="#008000">stage</font>).<font color="#008000">rect</font>.<font color="#008000">width</font>/<font color="#808080">2</font>,(<font color="#0000C8">the</font> <font color="#008000">stage</font>).<font color="#008000">rect</font>.<font color="#008000">height</font>/<font color="#808080">2</font>)</font></p>
<p><font color="#000000" face="Verdana, Arial, Helvetica, sans-serif" size="-1">&nbsp;&nbsp;<font color="#C80000" face="Courier New, Courier, mono" size="-1">-- loop through frames of Flash movie and create list of images</font><br />
&nbsp;&nbsp;pImages = []<br />
&nbsp;&nbsp;pNumberOfImages = <font color="#008000">sprite</font>(<font color="#0000C8">me</font>.<font color="#008000">spriteNum</font>).<font color="#008000">member</font>.frameCount<br />
&nbsp;&nbsp;pFrameRate = <font color="#008000">sprite</font>(<font color="#0000C8">me</font>.<font color="#008000">spriteNum</font>).<font color="#008000">member</font>.<font color="#008000">frameRate</font></font></p>
<p><font color="#000000" face="Verdana, Arial, Helvetica, sans-serif" size="-1">&nbsp;&nbsp;<font color="#0000C8">repeat</font> <font color="#0000C8">with</font> i = <font color="#808080">1</font> <font color="#0000C8">to</font> pNumberOfImages<br />
&nbsp;&nbsp;&nbsp;&nbsp;<font color="#008000">sprite</font>(<font color="#0000C8">me</font>.<font color="#008000">spriteNum</font>).goToFrame(i)<br />
&nbsp;&nbsp;&nbsp;&nbsp;<font color="#008000">updateStage</font><br />
&nbsp;&nbsp;&nbsp;&nbsp;image = (<font color="#0000C8">the</font> <font color="#008000">stage</font>).image<br />
&nbsp;&nbsp;&nbsp;&nbsp;<font color="#008000">add</font> pImages, image.<font color="#008000">crop</font>(<font color="#008000">sprite</font>(<font color="#0000C8">me</font>.<font color="#008000">spriteNum</font>).<font color="#008000">rect</font>)<br />
&nbsp;&nbsp;<font color="#0000C8">end</font> <font color="#0000C8">repeat</font></font></p>
<p><font color="#000000" face="Verdana, Arial, Helvetica, sans-serif" size="-1">&nbsp;&nbsp;<font color="#C80000" face="Courier New, Courier, mono" size="-1">-- reset location of sprite</font><br />
&nbsp;&nbsp;<font color="#008000">sprite</font>(<font color="#0000C8">me</font>.<font color="#008000">spriteNum</font>).<font color="#008000">loc</font> = origLoc</font></p>
<p><font color="#000000" face="Verdana, Arial, Helvetica, sans-serif" size="-1">&nbsp;&nbsp;<font color="#C80000" face="Courier New, Courier, mono" size="-1">-- create new member and set sprite to use it</font><br />
&nbsp;&nbsp;pMember = <font color="#0000C8">new</font>(<font color="#008000">#</font>bitmap)<br />
&nbsp;&nbsp;<font color="#008000">sprite</font>(<font color="#0000C8">me</font>.<font color="#008000">spriteNum</font>).<font color="#008000">member</font> = pMember</font></p>
<p><font color="#000000" face="Verdana, Arial, Helvetica, sans-serif" size="-1">&nbsp;&nbsp;<font color="#C80000" face="Courier New, Courier, mono" size="-1">-- set image properties</font><br />
&nbsp;&nbsp;pImageNum = <font color="#808080">0</font><br />
&nbsp;&nbsp;pNextFrame = <font color="#808080">0</font></font></p>
<p><font color="#000000" face="Verdana, Arial, Helvetica, sans-serif" size="-1">&nbsp;&nbsp;<font color="#C80000" face="Courier New, Courier, mono" size="-1">-- start showing images</font><br />
&nbsp;&nbsp;showNextImage(<font color="#0000C8">me</font>)</font></p>
<p><font color="#000000" face="Verdana, Arial, Helvetica, sans-serif" size="-1">&nbsp;&nbsp;<font color="#C80000" face="Courier New, Courier, mono" size="-1">-- remember that we don't need to do this again</font><br />
&nbsp;&nbsp;pGotImages = <font color="#0000C8">TRUE</font></font></p>
<p><font color="#000000" face="Verdana, Arial, Helvetica, sans-serif" size="-1"><font color="#0000C8">end</font></font></p>
<p><font color="#000000" face="Verdana, Arial, Helvetica, sans-serif" size="-1"><b><br />
<font color="#0000C8">on</font> showNextImage <font color="#0000C8">me</font></b></font></p>
<p><font color="#000000" face="Verdana, Arial, Helvetica, sans-serif" size="-1">&nbsp;&nbsp;<font color="#C80000" face="Courier New, Courier, mono" size="-1">-- see if it is time for next image</font><br />
&nbsp;&nbsp;<font color="#0000C8">if</font> <font color="#0000C8">the</font> <font color="#008000">milliseconds</font> &gt; pNextFrame <font color="#0000C8">then</font><br />
&nbsp;&nbsp;&nbsp;&nbsp;<br />
&nbsp;&nbsp;&nbsp;&nbsp;<font color="#C80000" face="Courier New, Courier, mono" size="-1">-- increment image, loop back if past last</font><br />
&nbsp;&nbsp;&nbsp;&nbsp;pImageNum = pImageNum + <font color="#808080">1</font><br />
&nbsp;&nbsp;&nbsp;&nbsp;<font color="#0000C8">if</font> pImageNum &gt; pNumberOfImages <font color="#0000C8">then</font> pImageNum = <font color="#808080">1</font><br />
&nbsp;&nbsp;&nbsp;&nbsp;<br />
&nbsp;&nbsp;&nbsp;&nbsp;<font color="#C80000" face="Courier New, Courier, mono" size="-1">-- set image</font><br />
&nbsp;&nbsp;&nbsp;&nbsp;pMember.image = pImages[pImageNum]<br />
&nbsp;&nbsp;&nbsp;&nbsp;<br />
&nbsp;&nbsp;&nbsp;&nbsp;<font color="#C80000" face="Courier New, Courier, mono" size="-1">-- set time for next image</font><br />
&nbsp;&nbsp;&nbsp;&nbsp;pNextFrame = <font color="#0000C8">the</font> <font color="#008000">milliseconds</font> + <font color="#808080">1000</font>/pFrameRate<br />
&nbsp;&nbsp;&nbsp;&nbsp;<br />
&nbsp;&nbsp;<font color="#0000C8">end</font> <font color="#0000C8">if</font></font></p>
<p><font color="#000000" face="Verdana, Arial, Helvetica, sans-serif" size="-1"><font color="#0000C8">end</font></font></p>
<p><font color="#000000" face="Verdana, Arial, Helvetica, sans-serif" size="-1"><b><br />
<font color="#0000C8">on</font> <font color="#008000">exitFrame</font> <font color="#0000C8">me</font></b></font></p>
<p><font color="#000000" face="Verdana, Arial, Helvetica, sans-serif" size="-1">&nbsp;&nbsp;<font color="#0000C8">if</font> pGotImages <font color="#0000C8">then</font><br />
&nbsp;&nbsp;&nbsp;&nbsp;<font color="#C80000" face="Courier New, Courier, mono" size="-1">-- see if time for next image</font><br />
&nbsp;&nbsp;&nbsp;&nbsp;showNextImage(<font color="#0000C8">me</font>)<br />
&nbsp;&nbsp;<font color="#0000C8">else</font><br />
&nbsp;&nbsp;&nbsp;&nbsp;<font color="#C80000" face="Courier New, Courier, mono" size="-1">-- initialize</font><br />
&nbsp;&nbsp;&nbsp;&nbsp;getImages(<font color="#0000C8">me</font>)<br />
&nbsp;&nbsp;<font color="#0000C8">end</font> <font color="#0000C8">if</font></font></p>
<p><font color="#000000" face="Verdana, Arial, Helvetica, sans-serif" size="-1"><font color="#0000C8">end</font></font></p>
<p><font color="#000000" face="Verdana, Arial, Helvetica, sans-serif" size="-1"><b><br />
<font color="#0000C8">on</font> <font color="#008000">endSprite</font> <font color="#0000C8">me</font></b></font></p>
<p><font color="#000000" face="Verdana, Arial, Helvetica, sans-serif" size="-1">&nbsp;&nbsp;<font color="#C80000" face="Courier New, Courier, mono" size="-1">-- sprite done, get rid of the evidence</font><br />
&nbsp;&nbsp;erase pMember</font></p>
<p><font color="#000000" face="Verdana, Arial, Helvetica, sans-serif" size="-1"><font color="#0000C8">end</font></font></p>
<p>This behavior is pretty good at imitating an animated Flash movie, taking into account the frame rate and all. You can even take into account things like Flash member quality, looping, pausedAtStart, and goToFrame calls by adding additional functionality to the behavior above. I'll leave those as an exercise for the reader.</p>
<p>Here is a demo movie that uses this technique. It times the movement of an animated Flash member across the Stage. I used the two-frame animated biplane from the Flash library for the example.</p>
<p><object classid="clsid:166B1BCA-3F9C-11CF-8075-444553540000" codebase="http://active.macromedia.com/director/cabs/sw.cab#version=6,0,1,0" width="500" height="300"><param name="SRC" value="howto/other/LL24_2.dcr" />
<param name="swRemote" value="swTarget='false'" />
<param name="swLiveConnect" value="FALSE" />
<embed src="howto/other/LL24_2.dcr" pluginspage="http://www.macromedia.com/shockwave/download/" type="application/x-director" width="500" height="300" swliveconnect="FALSE" swremote="swTarget='false'" /> </object></p>
<p>Director 8 sample movies are available for download in <a href="howto/other/LL24.sit">Mac</a> or <a href="howto/other/LL24.zip">PC</a> format.</p>
<p>First, let's look at the results with a static image. It takes 15000 milliseconds to cross the screen, even with <font face="Courier, monotype" color="#CC0000">pausedAtStart</font> and <font face="Courier, monotype" color="#CC0000">static</font> properties turned on. Converting it to a bitmap first gives the result of 6000 milliseconds. Quite an improvement. This large, irregular shape shows a much bigger gap between using a bitmap and using a Flash movie than my previous red ball tests.</p>
<p>Now, let's try it animated. The result for the Flash movie is the same: 15000 milliseconds. That is interesting in itself. The animated Flash movie is as slow as the "static" one. So much for the static setting having much effect on a Flash movie like this. I got similar results in Shockwave on the PC.</p>
<p>Now, let's use the nifty behavior that converts the animation to a list of images. It takes 7000 milliseconds to cross the Stage. That's only slightly more than the non-animated version. This shows that the bitmap image swaps are taking up only a little bit of time. This is good news, as we now have a way to double the speed of this Flash animation.</p>
<p>Better yet, it is a nice, neat way of speeding up Flash -- no leftover members, no conversion process, just a simple behavior. We can actually do the same thing with those slow text members... but I'll save that for another week.</p>
<p>Gary Rosenzweig's new book "Special Edition Using Director 8" is now available. It's the most comprehensive guide to Director ever, including tons of examples and demo movies. It's suitable for novices and experts alike. More information about the book can be found at <a href="http://clevermedia.com/resources/bookstore/book5.html" target="_blank">http://clevermedia.com/resources/bookstore/book5.html</a>. It can be purchased there, or in your local bookstore.</p><div class="about">Gary Rosenzweig is the Chief Engineer, founder, and owner of
<a href="http://www.clevermedia.com" target="_blank">CleverMedia</a>, a game and multimedia development company in Denver,
Colorado. He is the author of ten books on Macromedia Director and Flash, including his latest, <a href="http://garyrosenzweig.com/books/" target="_blank">Special Edition Using Director MX</a>.
</div>

<p class="dsmall">Copyright 1997-2022, Director Online. Article content copyright by respective authors.</p>
</div>
</div>
</body>
</html>